% ----------------------
% FSS.m
% ----------------------
% computes final steady state
% ----------------------

t       = tend;

x0SS    = ones(4,1);

[x1, retcode] = findroot(@SS,x0SS);
   
if retcode~=0 error('Root finder in FSS did not converge!'); end

% take final steady states values as guesses for the path
guess   = kron([V(tend) Hv(:,tend)' Omegav(:,tend)'],ones(tend,1));

% take linear combination of initial and final steady states values as guesses for the path
%guess   = kron([V0 Hv0' Omegav0'],(1-(0:1/(tend-1):1))')+kron([V(tend) Hv(:,tend)' Omegav(:,tend)'],(0:1/(tend-1):1)');