% ----------------------
% compdemo.m
% ----------------------
% computes the calibration demography
% ----------------------

global N0 NB0 Nv0 nag gamv0 ivv0

% enter a path of survival propabilities
%gamv0(1:60,1)  = (0.999:-(0.999-0.95)/59:0.95)';
%gamv0(61:80,1) = (0.95:-(0.95/20):0.95/20)';

%gamv0 = 0.98*ones(nag,1);
%gamv0 = ones(nag,1);

%smooth decay, smooth parameter: 0.89 works for nag = 80
gamv0 = 1-0.89.^(nag:-1:1)';

% survival of last age group is 0
gamv0(nag) = 0;

% compute average age
gamv02 = [gamv0;0]; lifeexpect  = 0;
for i=1:nag
    lifeexpect = lifeexpect + i*(1-gamv02(i+1))*prod(gamv02(1:i));
end
fprintf('LIFE EXPECT: \t\t\t %4.5f\n',lifeexpect);

% DEMOGRAPHY
Nv0(1)   = 1;
for i=2:nag
    Nv0(i,1)= Nv0(i-1)*gamv0(i-1);
end
% rescale population
NB0 = 1/sum(Nv0)*N0;
Nv0 = Nv0/sum(Nv0)*N0;

fprintf('CHECK: POPULATION: \t\t %4.5f\n',sum((1-gamv0).*Nv0)-NB0);

% Compute neutral intervivo-transfers
ivv0            = zeros(nag,1);         % inter-vivo transfers

ivv0(1:nwg0,1)       = ones(nwg0,1).*0.3;   % set to get nice asset profile
ivv0(nwg0+1:nag,1)   = -sum(ivv0.*Nv0)/sum(Nv0(nwg0+1:nag)).*ones(nag-nwg0,1);
if abs(sum(ivv0.*Nv0))>1e-10 
    error('Unbalanced intervivo transfers');
end