% ----------------------
% findwelfare.m
% ----------------------
% computes difference between post-reform indirect utility
% and indirect utility based on scaled calibration consumption
% in:   guess for scaling factor, age
% out:  resid
% ----------------------

function resid = findwelfare(inputs,age)

    global Vvpath VvFSS Qv0 Cv0 gamv G rho nag tend sigma
    
    disutil = Cv0-Qv0;
    
    rho2 = (sigma-1)/sigma;
    
    scaleC     = inputs;
       
    Vvpath2new                               = zeros(nag,tend+nag);
    Vvpath2new(nag,(nag-age+1):tend+nag)     = 1/rho2*(Cv0(nag)*scaleC-disutil(nag)).^rho2;
    
    gamv2   = [gamv, kron(gamv(:,tend),ones(1,nag))];

    for a=(nag-1):-1:age
        Vvpath2new(a,(a-age+1):(tend+a)) = 1/rho2*(Cv0(a).*scaleC-disutil(a)).^rho2 + 1/(1+rho)*gamv2(a,(a-age+1):(tend+a))*G^rho2.*Vvpath2new(a+1,(a-age+2):(tend+a+1));
    end
    
    Vvpathtarget = [Vvpath, kron(VvFSS,ones(1,nag))];
        
    resid   = Vvpath2new(age,(1:tend+age))-Vvpathtarget(age,(1:tend+age));
    
end