% ----------------------
% findwelfareFSS.m
% ----------------------
% computes difference between post-reform indirect utility
% and indirect utility based on scaled calibration consumption for FSS
% in:   guess for scaling factor, age
% out:  resid
% ----------------------

function resid = findwelfareFSS(inputs,age)

    global VvFSS Qv0 Cv0 gamv G rho nag tend sigma
    
    disutil = Cv0-Qv0;
    
    rho2 = (sigma-1)/sigma;
    
    scaleC     = inputs;
       
    VvFSSnew        = zeros(nag,1);
    VvFSSnew(nag)   = 1/rho2*(Cv0(nag)*scaleC-disutil(nag)).^rho2;
    
    for a=(nag-1):-1:age
        VvFSSnew(a) = 1/rho2*(Cv0(a)*scaleC-disutil(a)).^rho2 + 1/(1+rho)*gamv(a,tend)*G^rho2.*VvFSSnew(a+1);
    end
        
    resid   = VvFSSnew(age)-VvFSS(age);
    
end