% ----------------------
% recompdemo.m
% ----------------------
% recomputes the demography after a possible shock;
% as it is unaffected by economic decisions one can
% compute the whole path in advance
% ----------------------

global tend NB Nv N nag gamv ivv notretv

% compute average age
gamv02 = [gamv(:,tend);0]; lifeexpect  = 0;
for i=1:nag
    lifeexpect = lifeexpect + i*(1-gamv02(i+1))*prod(gamv02(1:i));
end
fprintf('\nLIFE EXPECT FSS: \t\t %4.5f\n',lifeexpect);

% DEMOGRAPHY
for t=2:tend-1
    Nv(1,t)   = NB(1,t);
    for i=2:nag
        Nv(i,t)= Nv(i-1,t-1)*gamv(i-1,t-1);
    end
    N(t)      = sum(Nv(:,t));
end

% FSS
Nv(1,tend)       = NB(tend);
for i=2:nag
    Nv(i,tend)= Nv(i-1,tend)*gamv(i-1,tend);
end
N(tend)       = sum(Nv(:,tend));

% indicator for retirement
notretv(:,tend)                   = zeros(nag,1);
notretv(1:floor(nwg(tend)),tend)  = ones(floor(nwg(tend)),1);
notretv(floor(nwg(tend))+1,tend)  = nwg(tend)-floor(nwg(tend));

fprintf('DEPENDENCY RATIO FSS: \t\t %4.5f\n',(Nv(:,tend)'*(1-notretv(:,tend)))/(Nv(:,tend)'*notretv(:,tend)));

% Compute neutral intervivo-transfers
% rescaling of received intervivo-transfers
for t=2:tend
    ivgiven           = -sum(Nv(:,t).*ivv(:,t).*(ivv(:,t)<0));
    ivreceived        = sum(Nv(:,t).*ivv(:,t).*(ivv(:,t)>0));
    ivv(ivv(:,t)>0,t) = ivv(ivv(:,t)>0,t).*(ivgiven/ivreceived);
    if abs(sum(ivv(:,t).*Nv(:,t)))>1e-10 
        error('Unbalanced intervivo transfers');
    end
end

