% ----------------------
% welfare.m
% ----------------------
% computes welfare changes as relative changes in indirect utility
% ----------------------

global Vvpath Vvpath0 Vv0 VvFSS

rho2 = (sigma-1)/sigma;

Vv0         = zeros(nag,1);
Vv0(nag)    = 1/rho2*Qv0(nag)^rho2;

for a=(nag-1):-1:1
    Vv0(a) = 1/rho2*Qv0(a)^rho2 + 1/(1+rho)*gamv0(a)*G^rho2*Vv0(a+1);
end

Vvpath0 = kron(Vv0,ones(1,tend));

VvFSS       = zeros(nag,1);
VvFSS(nag)  = 1/rho2*Qv(nag,tend)^rho2;

for a=(nag-1):-1:1
    VvFSS(a) = 1/rho2*Qv(a,tend)^rho2 + 1/(1+rho)*gamv(a,tend)*G^rho2*VvFSS(a+1);
end

Vvpath2                     = zeros(nag,tend+nag);
Vvpath2(nag,1:tend)         = 1/rho2*Qv(nag,1:tend).^rho2;
Vvpath2(:,tend+1:tend+nag)  = kron(VvFSS,ones(1,nag));

Qv2     = [Qv, kron(Qv(:,tend),ones(1,nag))];
gamv2   = [gamv, kron(gamv(:,tend),ones(1,nag))];

for a=(nag-1):-1:1
    Vvpath2(a,1:(tend+nag-(nag-a))) = 1/rho2*Qv2(a,1:(tend+nag-(nag-a))).^rho2 + 1/(1+rho)*gamv2(a,1:(tend+nag-(nag-a)))*G^rho2.*Vvpath2(a+1,2:(tend+nag-(nag-a)+1));
end

Vvpath = Vvpath2(:,1:tend);

%Vvchange = Vvpath./Vvpath0-1;
Vvchange = (Vvpath-Vvpath0)./abs(Vvpath0);

