% ----------------------
% welfareC.m
% ----------------------
% computes welfare changes as relative changes in consumption 
% for the rest of the life
% ----------------------

% run 'welfare' before

CvchangeFSS = zeros(nag,1);

for a=nag:-1:1
    options = optimoptions('fsolve','Display','off');
    [x1, x1val, retcode] = fsolve(@(x)findwelfareFSS(x,a),1,options);
    if retcode~=1 error('Root finder in calib did not converge!'); end
    CvchangeFSS(a) = x1-1;
end

Cvchange = zeros(nag,tend);

h = waitbar(0,'Computing welfare changes in consumption equivalent terms. Please wait...');

for a=nag:-1:1
    options = optimoptions('fsolve','Display','off');
    [x1, x1val, retcode] = fsolve(@(x)findwelfare(x,a),ones(1,tend+a),options);
    if retcode~=1 error('Root finder in calib did not converge!'); end
    Cvchange(a,:) = x1(1:tend)-1;
    waitbar((nag-a)/nag)
end
close(h)